// ================================================================
// $Id: configh.h $
//
// configh.h
//
//      Global configuration things for header files.
//
// REPLACEMENT_STRING
//
// Copyright by Vlastimil Havran, 2006 - email to "vhavran AT seznam.cz"
// Initial coding by Vlastimil Havran, 2000.

#ifndef __CONFIGH_H__
#define __CONFIGH_H__

#ifndef USE_GOLEM_NAMESPACE
// without namespaces
#define  __BEGIN_GOLEM_HEADER
#define  __END_GOLEM_HEADER
#else
// with namespace 
#define NAMESPACEDEF     GOLEMLIB
// use of namespace commands inside the library sources
#define  __BEGIN_GOLEM_HEADER namespace NAMESPACEDEF { using namespace NAMESPACEDEF;
#define  __END_GOLEM_HEADER
#endif


__BEGIN_GOLEM_HEADER

// definition of numeric data types in the library

// floating point type (min. 4 bytes, IEEE754 single)
typedef float float4;
// floating point type (min.  8 bytes, IEEE754 double)
typedef double float8;
// floating point type (min. 12 bytes, IEEE854 extended)
typedef long double float12;

// unsigned byte type (exactly 1 byte)
typedef unsigned char byte;
// unsigned integer type (min. 1 byte)
typedef unsigned char uint1;
// signed integer type (min. 1 byte)
typedef signed char int1;

// unsigned integer type (min. 2 bytes)
typedef unsigned short int uint2;
// signed integer type (min. 2 bytes)
typedef signed short int int2;

// unsigned integer type (min. 4 bytes)
typedef unsigned int uint4;
// signed integer type (min. 4 bytes)
typedef signed int int4;

// signed integer type (min. 8 bytes)
// -- see file int8.h

#ifdef _MSC_VER
#define __SSE__
// disable some Microsoft Visual Compiler warnings if necessary
#pragma warning( disable:4305 )
#pragma warning( disable:4786 )
#pragma warning( disable:4800 )
#pragma warning( disable:4244 )
#ifdef min
#undef min
#endif
#ifdef max
#undef max
#endif
#ifdef ERROR
#undef ERROR
#endif
#ifdef GetObject
#undef GetObject
#endif
#endif // _MSC_VER
 
#ifndef _EXPORT_
#if defined(_MSC_VER)
#define _EXPORT_  __declspec(dllexport)
#else
#define _EXPORT_ 
#endif
#endif
 
__END_GOLEM_HEADER

#endif // __CONFIGH_H__

